package at.ac.uibk.gitsearch.service;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

/**
 * Service for exercise/course search results
 * <p>
 */
@Service
public class ShoppingBasketService {
	
	public static class ShoppingBasket {
		private UserInfo userInfo;
		private ExerciseInfo[] exerciseInfo;
		
		
		public ShoppingBasket(UserInfo userInfo, ExerciseInfo[] exerciseInfo) {
			super();
			this.userInfo = userInfo;
			this.exerciseInfo = exerciseInfo;
		}
		/**
		 * @return the userInfo
		 */
		public UserInfo getUserInfo() {
			return userInfo;
		}
		/**
		 * @param userInfo the userInfo to set
		 */
		public void setUserInfo(UserInfo userInfo) {
			this.userInfo = userInfo;
		}
		/**
		 * @return the exerciseInfo
		 */
		public ExerciseInfo[] getExerciseInfo() {
			return exerciseInfo;
		}
		/**
		 * @param exerciseInfo the exerciseInfo to set
		 */
		public void setExerciseInfo(ExerciseInfo[] exerciseInfo) {
			this.exerciseInfo = exerciseInfo;
		}
	}
	public static class UserInfo {
		String email;

		public UserInfo(String email) {
			super();
			this.email = email;
		}

		/**
		 * @return the email
		 */
		public String getEmail() {
			return email;
		}

		/**
		 * @param email the email to set
		 */
		public void setEmail(String email) {
			this.email = email;
		}
	}
	
	public static class ExerciseInfo {
		private String gitLabURI;
		private int gitLabProjectId;
		private String title;

		public ExerciseInfo(String title, int gitLabProjectId, String gitLabURI) {
			super();
			this.title = title;
			this.setGitLabProjectId(gitLabProjectId);
			this.gitLabURI = gitLabURI;
		}

		/**
		 * @return the title
		 */
		public String getTitle() {
			return title;
		}

		/**
		 * @param title the title to set
		 */
		public void setTitle(String title) {
			this.title = title;
		}

		/**
		 * @return the gitLabURI
		 */
		public String getGitLabURI() {
			return gitLabURI;
		}

		/**
		 * @param gitLabURI the gitLabURI to set
		 */
		public void setGitLabURI(String gitLabURI) {
			this.gitLabURI = gitLabURI;
		}

		public int getGitLabProjectId() {
			return gitLabProjectId;
		}

		public void setGitLabProjectId(int gitLabProjectId) {
			this.gitLabProjectId = gitLabProjectId;
		}
		
	}

	private final Logger log = LoggerFactory.getLogger(ShoppingBasketService.class);


	public ShoppingBasketService() {

	}
	
	public ShoppingBasket getBasket(String basketToken) {
		final UserInfo userInfo = new UserInfo("Michael.Breu@uibk.ac.at");
		final ExerciseInfo exerciseInfo = new ExerciseInfo("JUnit Quality Tests Exercise", 3, "https://sharing.codeability-austria.uibk.ac.at/sharing/university-innsbruck/java/general/junit-quality-tests-exercise.git");
		final ShoppingBasket shoppingBasket = new ShoppingBasket(userInfo, new ExerciseInfo[] {exerciseInfo});
		return shoppingBasket;
	}

}
